"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.inflateToTree = void 0;
const key_tree_1 = require("./key-tree");
const key_tree_to_node_tree_1 = require("./key-tree-to-node-tree");
const multiRootNodeId = '';
function inflateToTree(rawData, idSelector) {
    const paths = rawData.map(idSelector);
    const treeSkeleton = key_tree_1.buildKeyTree(paths);
    const rootItems = Object.entries(treeSkeleton);
    const [rootKey, rootNode] = rootItems.length === 1 ? rootItems[0] : [multiRootNodeId, treeSkeleton];
    const tree = key_tree_to_node_tree_1.keyTreeToNodeTree(rootKey, rootNode);
    return tree;
}
exports.inflateToTree = inflateToTree;
//# sourceMappingURL=inflate-paths.js.map