"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildKeyTree = void 0;
const base_ui_utils_sub_paths_1 = require("@teambit/base-ui.utils.sub-paths");
/**
 * builds a skeleton of the tree.
 * @example
 * input: ['hello/world']
 * output: {
 *    'hello/': {
 *      'hello/world': undefined
 *    }
 * }
 */
function buildKeyTree(paths) {
    const treeRoot = {};
    paths.forEach((fullpath) => {
        const segments = base_ui_utils_sub_paths_1.subPaths(fullpath).filter((x) => x !== '.'); // @HACK!
        const isFolder = fullpath.endsWith('/');
        const fileName = isFolder ? undefined : segments.pop();
        let currentFolder = treeRoot;
        segments.forEach((dirname) => {
            const folderId = `${dirname}/`;
            const nextFolder = currentFolder[folderId] || makeNode();
            currentFolder[folderId] = nextFolder;
            currentFolder = nextFolder;
        });
        if (fileName && !(fileName in currentFolder)) {
            currentFolder[fileName] = undefined;
        }
    });
    return treeRoot;
}
exports.buildKeyTree = buildKeyTree;
function makeNode() {
    return Object.create(null);
}
//# sourceMappingURL=key-tree.js.map