import { ComponentType } from 'react';
import { PayloadType } from '../payload-type';
export declare type treeNodeComponentProvider = (node: TreeNode) => ComponentType<TreeNodeProps>;
export declare type TreeLayerProps<Payload = any> = {
    childNodes: TreeNode<Payload>[];
    depth: number;
};
export declare type TreeNodeProps<Payload = any> = {
    node: TreeNode<Payload>;
    depth: number;
    TreeNode?: TreeNodeProps<PayloadType>;
};
export declare type TreeNode<Payload = any> = {
    id: string;
    children?: TreeNode<Payload>[];
    payload?: Payload;
};
export declare type StatusTypes = 'modified' | 'error' | 'new' | 'staged';
